{*******************************************************************************
 Project       : "Space Shooter ..." ?
 Date          : 2007-07-11
 Version       : 1.3
 Compiler Ver. : Delphi 2007
 Author        : Denny Koberling
 E-Mail        : JasonVoorhees2k@arcor.de
 Copyright     : Copyright (c) 2007 Denny Koberling
*******************************************************************************}

unit UBackground;

interface

uses Graphics, USprite, UType, UAnimBmp;

type
  TBackground = class(TSprite)
  public
    constructor Create;
    procedure Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse); override;
    procedure Draw(aFrame: TBitmap); override;
  end;

implementation

{ TBackground }

constructor TBackground.Create;
begin
  inherited Create(nil, 'Galaxy', 9, 0, 0, 0.1);
  X:=Random(SCREEN_WIDTH-AnimBmp.Width);
  Y:=-AnimBmp.Height;
end;

procedure TBackground.Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse);
begin
  Y:=Y+Speed*aMoveCount;
  if Y>SCREEN_HEIGHT then begin
    FrameNr:=FrameNr+1;
    if FrameNr=AnimBmp.FrameCount[AnimNr] then
      FrameNr:=0;
    X:=Random(SCREEN_WIDTH-AnimBmp.Width);
    Y:=-AnimBmp.Height;
  end;
end;

procedure TBackground.Draw(aFrame: TBitmap);
begin
  DrawNormalSprite(aFrame, Round(X), Round(Y));
end;

end.
