{*******************************************************************************
 Project       : "Space Shooter ..." ?
 Date          : 2007-07-11
 Version       : 1.3
 Compiler Ver. : Delphi 2007
 Author        : Denny Koberling
 E-Mail        : JasonVoorhees2k@arcor.de
 Copyright     : Copyright (c) 2007 Denny Koberling
*******************************************************************************}

unit USpriteList;

interface

uses SysUtils, Classes, Contnrs, USprite;

type
  TSpriteList = class(TObject)
  private
    fSpriteList: TObjectList;
    function GetSprite(aIndex: Integer): TSprite;
    function GetCount: Integer;
  public
    constructor Create;
    destructor Destroy; override;
    procedure AddSprite(aSprite: TSprite);
    procedure Delete(aIndex: Integer);
    procedure DeleteDeadSprites;
    property Count: Integer read GetCount;
    property Sprite[aIndex: Integer]: TSprite read GetSprite; default;
  end;

implementation

{ TSpriteList }

constructor TSpriteList.Create;
begin
  inherited Create;
  fSpriteList:=TObjectList.Create;
end;

destructor TSpriteList.Destroy;
begin
  FreeAndNil(fSpriteList);
  inherited;
end;

procedure TSpriteList.AddSprite(aSprite: TSprite);
begin
  fSpriteList.Add(aSprite);
end;

procedure TSpriteList.Delete(aIndex: Integer);
begin
  fSpriteList.Delete(aIndex);
end;

function TSpriteList.GetSprite(aIndex: Integer): TSprite;
begin
  Result:=TSprite(fSpriteList[aIndex]);
end;

procedure TSpriteList.DeleteDeadSprites;
var i: Integer;
begin
  if fSpriteList.Count>0 then
    for i:=fSpriteList.Count-1 downto 0 do
      if TSprite(fSpriteList[i]).isDead then
        fSpriteList.Delete(i);
end;

function TSpriteList.GetCount: Integer;
begin
  Result:=fSpriteList.Count;
end;

end.
