{*******************************************************************************
 Project       : "Space Shooter ..." ?
 Date          : 2007-07-11
 Version       : 1.3
 Compiler Ver. : Delphi 2007
 Author        : Denny Koberling
 E-Mail        : JasonVoorhees2k@arcor.de
 Copyright     : Copyright (c) 2007 Denny Koberling
*******************************************************************************}

unit UStars;

interface

uses Graphics, USprite, UType;

type
  TStars = class(TSprite)
  private
    fStars: array[0..MAX_STARS-1] of record X, Y, Speed: Single end;
  public
    constructor Create;
    procedure Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse); override;
    procedure Draw(aFrame: TBitmap); override;
  end;

implementation

{ TStars }

constructor TStars.Create;
var
  i: Integer;
begin
  Layer:=8;
  for i:=0 to High(fStars) do begin
    fStars[i].X:=Random(SCREEN_WIDTH);
    fStars[i].Y:=Random(SCREEN_HEIGHT);
    fStars[i].Speed:=(Random(8)+3)/20;
  end;
end;

procedure TStars.Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse);
var
  i: Integer;
begin
  for i:=0 to High(fStars) do begin
    fStars[i].Y:=fStars[i].Y+fStars[i].Speed*aMoveCount;
    if Round(fStars[i].Y)>=SCREEN_HEIGHT then begin
      fStars[i].X:=Random(SCREEN_WIDTH);
      fStars[i].Y:=0;
    end;
  end;
end;

procedure TStars.Draw(aFrame: TBitmap);
var
  i: Integer;
begin
  for i:=0 to High(fStars) do
    PWord(Integer(aFrame.ScanLine[Round(fStars[i].Y)])+Round(fStars[i].X)*2)^:=cWhite;
end;

end.
