{*******************************************************************************
 Project       : "Space Shooter ..." ?
 Date          : 2007-06-30
 Version       : 1.3
 Compiler Ver. : Delphi 2007
 Author        : Denny Koberling
 E-Mail        : JasonVoorhees2k@arcor.de
 Copyright     : Copyright (c) 2007 Denny Koberling
*******************************************************************************}

unit UTimer;

interface

type
  TTimer = class(TObject)
  protected
    fInterval: Integer;
    fTime    : Single;
  public
    constructor Create(aInterval: Integer);
    function Fire(aMoveCount: Single): Boolean;
    procedure Reset(aInterval: Integer);
    property Interval: Integer read fInterval write fInterval;
  end;

implementation

{ TTimer }

constructor TTimer.Create(aInterval: Integer);
begin
  inherited Create;
  fInterval:=aInterval;
  fTime:=0;
end;

function TTimer.Fire(aMoveCount: Single): Boolean;
begin
  Result:=False;
  fTime:=fTime+aMoveCount;
  if fTime>=fInterval then begin
    fTime:=0;
    Result:=True;
  end;
end;

procedure TTimer.Reset(aInterval: Integer);
begin
  fInterval:=aInterval;
  fTime:=0;
end;

end.
