{*******************************************************************************
 Project       : "Space Shooter ..." ?
 Date          : 2007-07-11
 Version       : 1.3
 Compiler Ver. : Delphi 2007
 Author        : Denny Koberling
 E-Mail        : JasonVoorhees2k@arcor.de
 Copyright     : Copyright (c) 2007 Denny Koberling
*******************************************************************************}

unit UWeapon;

interface

uses Graphics, USprite, UType;

type
  TWeapon = class(TSprite);

  TPlayerWeapon = class(TWeapon);

  TEnemyWeapon = class(TWeapon);

  TPlayerWeapon1 = class(TPlayerWeapon)
  public
    constructor Create(aParent: TSprite; aX, aY, aSpeed: Single);
    procedure Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse); override;
    procedure Hit(aSprite: TSprite); override;
    function AllowHit(aSprite: TSprite): Boolean; override;
  end;

  TEnemyWeapon1 = class(TEnemyWeapon)
  public
    constructor Create(aParent: TSprite; aX, aY, aSpeed: Single);
    procedure Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse); override;
    procedure Hit(aSprite: TSprite); override;
    function AllowHit(aSprite: TSprite): Boolean; override;
  End;

  TEnemyWeapon2 = class(TEnemyWeapon)
  public
    constructor Create(aParent: TSprite; aX, aY, aSpeed: Single);
    procedure Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse); override;
    procedure Hit(aSprite: TSprite); override;
    function AllowHit(aSprite: TSprite): Boolean; override;
  End;

implementation

uses UEngine, UPlayer, UEnemy, UEffect;

{ TPlayerWeapon1 }

constructor TPlayerWeapon1.Create(aParent: TSprite; aX, aY, aSpeed: Single);
begin
  inherited Create(aParent, 'PlayerWeapon', 5, aX, aY, aSpeed);
end;

procedure TPlayerWeapon1.Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse);
begin
  inherited;
  Y:=Y-Speed*aMoveCount;
  if Y<-AnimBmp.Height then
    Dead;
end;

procedure TPlayerWeapon1.Hit(aSprite: TSprite);
begin
  if aSprite is TEnemy then
    with TPlayer1(Parent) do
      EnemyHitCount:=EnemyHitCount+1;
  if aSprite is TEnemyWeapon then
    Engine.SpriteList.AddSprite(TSmallBang.Create(Self, CenterX, CenterY));
  Dead;
end;

function TPlayerWeapon1.AllowHit(aSprite: TSprite): Boolean;
begin
  Result:=(aSprite is TEnemy) or (aSprite is TEnemyWeapon);
end;

{ TEnemyWeapon1 }

constructor TEnemyWeapon1.Create(aParent: TSprite; aX, aY, aSpeed: Single);
begin
  inherited Create(aParent, 'EnemyWeapon1', 5, aX, aY, aSpeed);
end;

procedure TEnemyWeapon1.Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse);
begin
  Y:=Y+Speed*aMoveCount;
  If Y>SCREEN_HEIGHT Then
    Dead;
end;

procedure TEnemyWeapon1.Hit(aSprite: TSprite);
begin
  if aSprite is TPlayer then
    Engine.SpriteList.AddSprite(TSmallBang.Create(Self, CenterX, CenterY));
  Dead;
end;

function TEnemyWeapon1.AllowHit(aSprite: TSprite): Boolean;
begin
  Result:=(aSprite is TPlayer) or (aSprite is TPlayerWeapon);
end;

{ TEnemyWeapon2 }

constructor TEnemyWeapon2.Create(aParent: TSprite; aX, aY, aSpeed: Single);
begin
  inherited Create(aParent, 'EnemyWeapon2', 5, aX, aY, aSpeed);
end;

procedure TEnemyWeapon2.Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse);
begin
  y:=y+Speed*aMoveCount;
  if y>SCREEN_HEIGHT then
    Dead;
end;

procedure TEnemyWeapon2.Hit(aSprite: TSprite);
begin
  if aSprite is TPlayer then
    Engine.SpriteList.AddSprite(TSmallBang.Create(Self, CenterX, CenterY));
  Dead;
end;

function TEnemyWeapon2.AllowHit(aSprite: TSprite): Boolean;
begin
  Result:=(aSprite is TPlayer) or (aSprite is TPlayerWeapon);
end;

end.
